(*------------------------------------------------------------
TEAM01
A
144
Target: LegionDelphi7; Platform: Win32; Comment: Borland Delphi 7 (Legionaries)
------------------------------------------------------------*)
{$APPTYPE CONSOLE}
program dbot;
uses
  SysUtils,
  Math;

const
	//   !
	PLAYER_NAME = 'ospu01';
	MAX_SIZE = 100;
type
	TPoint = record
		x: Integer;
		y: Integer;
	end;
	
	TCell = record
		owner: Integer;
		isVeteran: Boolean;
		isConnected: Boolean;
	end;

	TMap = array[0..MAX_SIZE, 0..MAX_SIZE] of TCell;

var
	me: Integer;
	size: Integer;
	map: TMap;
	legionsCount, countmyleg, countnotmyleg, countvet, max, maxx, maxy: Integer;
	city: array[0..1] of TPoint;

procedure InputData();
var
	i: Integer;
	x, y, t: Integer;
	c1, c2: char;
begin
	legionsCount := 5;
  countvet := 0;
  countmyleg := 0;
  countnotmyleg := 0;
	Readln(me);
	Readln(size);
	for i := 0 to 1 do
	  Readln(city[i].x, city[i].y);
  max := 0;
  maxx := city[me].x;
  maxy := city[me].y;
	for y := 0 to size-1 do
	begin
		for x := 0 to size - 1 do
		begin
			Read(c1);
			Read(c2);
			if (c1 <> '.') then
			begin
				map[x][y].isVeteran := c1 in ['V', 'v'];
				map[x][y].isConnected := c1 in ['N', 'V'];
				map[x][y].owner := StrToInt(c2);
				Read(c2);
        if map[x][y].isVeteran then
          inc(countvet);
        if map[x][y].owner = me then
          inc(countmyleg)
        else
          inc(countnotmyleg);
        if (map[x][y].owner = me) and (map[x][y].isConnected) then
        begin
          t := abs(x - city[me].x) + abs(y - city[me].y);
          if max < t then
          begin
            max := t;
            maxx := x;
            maxy := y;
          end;
        end;
			end
			else
			begin
				map[x][y].isVeteran := false;
				map[x][y].isConnected := false;
				map[x][y].owner := -1;
			end
		end;
		Readln;
	end;
end;

function IsMyConnected(x, y: Integer): Boolean;
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then result := false
	else result := (map[x][y].owner = me) and map[x][y].isConnected;
end;

function CanMoveTo(x, y: Integer): Boolean;
var
	c: TCell;
begin
	c := map[x][y];
	if c.owner = me then result := false
	else if (c.owner >= 0) and (legionsCount < 2) then result := false
	else if (c.owner >= 0) and (c.isVeteran) and (legionsCount < 3) then result := false
	else result := IsMyConnected(x-1, y) or IsMyConnected(x+1, y)
				or IsMyConnected(x, y-1) or IsMyConnected(x, y+1);
end;

procedure DFS(x, y: Integer; owner: Integer);
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then exit;
	if map[x,y].owner <> owner then exit;
	if map[x,y].isConnected then exit;
	map[x,y].isConnected := true;
	DFS(x, y-1, owner);
	DFS(x, y+1, owner);
	DFS(x-1, y, owner);
	DFS(x+1, y, owner);
end;

//  .       .
procedure Reconnect;
var
	x, y: Integer;
begin
	for y:=0 to size-1 do
		for x:=0 to size-1 do
			map[x,y].isConnected := false;
	DFS(city[0].x, city[0].y, 0);
	DFS(city[1].x, city[1].y, 1);
end;

procedure MoveTo(x, y: Integer);
var
	c: Integer;
begin
	Writeln(ErrOutput, 'go to ', x, ' ', y);
	if (map[x][y].owner = me) or (map[x][y].owner = -1) then c := 1
	else if map[x][y].isVeteran then c := 3
	else c := 2;
	if (legionsCount >= c) then
	begin
		map[x][y].owner := me;
		map[x][y].isVeteran := c > 1;
		map[x][y].isConnected := true;
	end;
	Writeln(x, ' ', y, ' ', Min(legionsCount, c));
	Dec(legionsCount, c);
	Reconnect();
end;



procedure Move();
var
	ps: array[0..MAX_SIZE*MAX_SIZE] of TPoint;
	bcount: Integer;

	procedure FindAccessiblePoints;
	var
		x, y: Integer;
	begin
		bcount := 0;
		for y := 0 to size-1 do
			for x := 0 to size-1 do
			begin
				if CanMoveTo(x, y)then
				begin
					ps[bcount].x := x;
					ps[bcount].y := y;
					Inc(bcount);
				end
			end;
	end;

 function rest(p: TPoint): integer;
 begin
   result := abs(p.x - city[me].x) * abs(p.y - city[me].y);
 end;

const
  maxind = 6;
var
	p: TPoint;
	maxx, max, i: Integer;
  inda: array [1..maxind] of Integer;
begin
  while legionsCount > 2 do
	begin
    FindAccessiblePoints();
		if bcount = 0 then
      break;
    for i := 1 to maxind do
		  inda[i] := Random(bcount);
    max := rest(ps[inda[1]]);
    maxx := 1;
    for i := 2 to maxind do
      if max < rest(ps[inda[i]]) then
      begin
        max := rest(ps[inda[i]]);
        maxx := i;
      end;
		p := ps[maxx];
		MoveTo(p.x, p.y);
	end;

  while legionsCount > 0 do
	begin
    FindAccessiblePoints();
		if bcount = 0 then exit;
	  inda[1] := Random(bcount);
		p := ps[inda[1]];
		MoveTo(p.x, p.y);
	end;
end;

procedure DoDiag(cx, cy: longint; count: longint);
var
  dd, k, i: longint;
begin
  dd := 1 - 2 * me;
  if cx = cy then
    k := 1
  else
    k := 0;

  for i := 1 to count do
  begin
    cx := cx + dd * k;
    k := (k + 1) mod 2;
    cy := cy + dd * k;
    MoveTo(cx, cy);
  end;
end;

begin
	Randomize();
	if SeekEOF then
		Writeln(PLAYER_NAME)
	else
	begin
		InputData();
    if countmyleg = 1 then
    begin
      if me = 0 then
        DoDiag(0, 0, 5)
      else
        DoDiag(size-1, size-1, 5);
    end
    else if countmyleg = 6 then
    begin
      if me = 0 then
        DoDiag(3, 2, 5)
      else
        DoDiag(size-4, size-3, 5);
    end
    else if countvet = 0 then
    begin
      Move();
    end
    else
		  Move();
	end;
end.
