/*------------------------------------------------------------
TEAM10
A
176
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#include <stdio.h>

struct LLL
{
	int X, Y;
};

enum State {free, we, en};
	enum Rang {nov, vet};
	struct TPoint
	{
		State st;
		bool IsConnected;
		Rang leg;
		int cost;
	};


class TQueue
{
public:
	int Head, Tail;
	LLL  Data[289];
	TQueue(): Head(0), Tail(0)
	{	}
	void push(int x, int y)
	{
		Data[Tail].X = x;
		Data[Tail++].Y = y;
		Tail = Tail % 289;
	}
	void pop(int &x, int &y)
	{
		x = Data[Head].X;
		y = Data[Head++].Y;
		Head = Head % 289;
	}
	bool IsEmpty()
	{
		return Head == Tail;
	}
};



	TPoint Field[17][17];

char NumPl;
int Size;
int ourX, ourY, emX, emY;
int Cost[17][17];
TQueue Q;

void macro1(int XPARAM, int YPARAM, int X, int Y)
{
				
			if (Cost[XPARAM][YPARAM] > Cost[X][Y])
			{
				if (Field[XPARAM][YPARAM].st == free)
				{
					Cost[XPARAM][YPARAM] = Cost[X][Y] + 1;
					Q.push(XPARAM, YPARAM);
				}
				else if (Field[XPARAM][YPARAM].st == we)
				{
					Cost[XPARAM][YPARAM] = Cost[X][Y] + 1;
					Q.push(XPARAM, YPARAM);
				}
				else
				{
					if (Field[XPARAM][YPARAM].leg == vet)
					{
						Cost[XPARAM][YPARAM] = Cost[X][Y] + 3;
						Q.push(XPARAM, YPARAM);
					}
					else
					{
						Cost[XPARAM][YPARAM] = Cost[X][Y] + 2;
						Q.push(XPARAM, YPARAM);
					}
				}
			}
}

int prevX, prevY;

bool occ[17][17];

bool rec(int x, int y)
{
	occ[x][y] = true;
	if(x < 0 || x >= Size)
		return false;
	if(y < 0 || y >= Size)
		return false;
	if(Cost[x][y] == 0)
		return true;
	if(!occ[x-1][y] && rec(x - 1, y))
		if(Field[x][y].st != we)
			printf("%d %d %d", x, y, Field[x][y].cost);
	
	else if(!occ[x+1][y] &&rec(x + 1, y))
		if(Field[x][y].st != we)
			printf("%d %d %d", x, y, Field[x][y].cost);
	else if(!occ[x][y-1] &&rec(x , y - 1))
		if(Field[x][y].st != we)
			printf("%d %d %d", x, y, Field[x][y].cost);
	else if(!occ[x][y+1] &&rec(x, y + 1))
		if(Field[x][y].st != we)
			printf("%d %d %d", x, y, Field[x][y].cost);
	return false;
}


bool getnext(int &x, int &y)
{
	int X = x, Y = y;
	prevX = x;
	prevY = y;
	if (X - 1 >= 0)
	{
		if (Cost[X - 1][Y] <= Cost[X][Y])
		{
			x = X - 1;
			y = Y;
			return true;
		}
	}
	if (X + 1 < Size)
	{
		if (Cost[X + 1][Y] <= Cost[X][Y])
		{
			x = X + 1;
			y = Y;
			return true;
		}
	}
	if (Y - 1 >= 0)
	{
		if (Cost[X][Y - 1] <= Cost[X][Y])
		{
			x = X;
			y = Y - 1;
			return true;
		}
	}
	if (Y + 1 < Size)
	{
		if (Cost[X][Y + 1] <= Cost[X][Y])
		{
			x = X;
			y = Y + 1;
			return true;
		}
	}
	return false;
}

int main()
{
	if (scanf("%s", &NumPl) == EOF)
	{
		printf("Legion10");
		return 0;
	}
	scanf("%d", &Size);
	if (NumPl == '1')
	{
		scanf("%d %d", &emX, &emY);
		scanf("%d %d", &ourX, &ourY);
	}
	else
	{
		scanf("%d %d", &ourX, &ourY);
		scanf("%d %d", &emX, &emY);
	}
	int i, j;
	char str[3];
	for (i = 0; i < Size; i++)
		for (j = 0; j < Size; j++)
		{
			scanf("%s", &str);
			if (str[0] == '.')
			{
				Field[i][j].st = free;
				continue;
			}
			if (str[1] == NumPl)
			{
				Field[i][j].st = we;
				switch (str[0])
				{
			    case 'n': Field[i][j].IsConnected = false; Field[i][j].leg = nov; Field[i][j].cost = 0; break;
				case 'N': Field[i][j].IsConnected = true; Field[i][j].leg = nov; Field[i][j].cost = 0; break;
				case 'v': Field[i][j].IsConnected = false; Field[i][j].leg = vet; Field[i][j].cost = 0; break;
				case 'V': Field[i][j].IsConnected = true; Field[i][j].leg = vet; Field[i][j].cost = 0; break;
				}
			}
			else
			{
				Field[i][j].st = en;
				switch (str[0])
				{
			    case 'n': Field[i][j].IsConnected = false; Field[i][j].leg = nov; Field[i][j].cost = 2; break;
				case 'N': Field[i][j].IsConnected = true; Field[i][j].leg = nov; Field[i][j].cost = 2; break;
				case 'v': Field[i][j].IsConnected = false; Field[i][j].leg = vet; Field[i][j].cost = 3; break;
				case 'V': Field[i][j].IsConnected = true; Field[i][j].leg = vet; Field[i][j].cost = 3; break;
				}
			}
			
		}
	for (i = 0; i < Size; i++)
		for (j = 0; j < Size; j++)
			Cost[i][j] = 6;
	Cost[ourX][ourY] = 0;
	Q.push(ourX, ourY);
	while (!Q.IsEmpty())
	{
		int X, Y;
		Q.pop(X, Y);
		if (Cost[X][Y] > 5)
			continue;
		if (X - 1 >= 0)
		{
			macro1(X-1, Y, X, Y);
		}
		if (X + 1 < Size)
		{
			macro1(X + 1, Y, X, Y);
		}
		if (Y - 1 >= 0)
		{
			macro1(X, Y - 1, X, Y);
		}
		if (Y + 1 < Size)
		{
			macro1(X, Y + 1, X, Y);
		}
	}
	int X, Y;
	if(ourX)
	{
		int min = 1000;
		for(i = 0; i < Size; ++i)
			for(j = 0; j < Size; ++j)
				if(Cost[i][j] <= 5)
				{
					if(i + j < min)
					{
						min = i + j;
						X = i;
						Y = j;
					}
				}
	}
	else
	{
		int max = 0;
		for(i = 0; i < Size; ++i)
			for(j = 0; j < Size; ++j)
				if(Cost[i][j] <= 5)
				{
					if(i + j > max)
					{
						max = i + j;
						X = i;
						Y = j;
					}
				}
	}
	
	
	for(i = 0; i < Size; ++i)
			for(j = 0; j < Size; ++j)
				occ[i][j] = false;
	rec(X, Y);
	return 0;
}
