/*------------------------------------------------------------
TEAM18
A
179
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <ctime>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXBUFLEN = 1000;
struct Point
{
	int x, y;
	Point(int x = 0, int y = 0)
	{
		this->x = x;
		this->y = y;
	}

	int Dist(Point &p)
	{
		return abs(x-p.x) + abs(y - p.y);
	}

	bool IsValid(int sz)
	{
		return x >= 0 && y >= 0 && x < sz && y < sz;
	}
};

struct Cell
{
	int owner;
	bool isVeteran;
	bool isConnected;
	Cell() : owner(-1), isVeteran(false), isConnected(false) {}
};

class SampleBot
{
	static char* BOT_NAME;
	static int maxLegions;
	int legionsCount;
	int me, enemy, size;
	int ourLeg;
	FILE* inf, *outf;

	Point city [2];

	Cell** map;
public:
	SampleBot(FILE* inf = NULL, FILE* outf = NULL) : map(NULL), size(0), legionsCount(maxLegions)
	{
		this->inf = (inf) ? inf : stdin;
		this->outf = (outf) ? outf : stdout;
	}
	~SampleBot()
	{
		if (map)
		{
			int x;
			for(x=0;x<size;++x)
				delete[] map[x];
			delete[] map;
		}
	}
	char* getName()
	{
		return BOT_NAME;
	}
	bool InputData()
	{
		srand(time(0));
		ourLeg = 0;
		char buffer[MAXBUFLEN];
		int i, x, y;
		if (2 != fscanf(inf, "%d%d", &me, &size))
			return false;
		enemy = 1 - me;
		map = new Cell* [size];
		for(i = 0; i < size; ++i)
			map[i] = new Cell[size];
		for(i = 0; i < 2; i++)
		{
			fscanf(inf,"%d%d",&city[i].x,&city[i].y);
		}
		for (y = 0; y < size; y++)
		{
			for (x = 0; x < size; x++)
			{
				fscanf(inf, "%s", buffer);
				char c1 = buffer[0];
				if (strncmp(buffer,".",1) != 0)
				{
					map[x][y].owner = buffer[1] - '0';
					map[x][y].isVeteran = (c1 == 'v' || c1 == 'V');
					map[x][y].isConnected = (c1 == 'N' || c1 == 'V');
					if (map[x][y].owner == me) ourLeg++;
				}
			}
		}
		return true;
	}
		
	/**/
	bool EnemyConnectedCell(int x, int y)
	{
		return (map[max(x-1, 0)][y].owner == enemy ||
				map[x][max(y-1, 0)].owner == enemy ||
				map[min(x+1, size-1)][y].owner == enemy ||
				map[x][min(y+1, size-1)].owner == enemy);
	}

	bool OurCell(int x, int y)
	{
		return (map[max(x-1, 0)][y].owner == me ||
				map[x][max(y-1, 0)].owner == me ||
				map[min(x+1, size-1)][y].owner == me ||
				map[x][min(y+1, size-1)].owner == me);
	}
	/**/

	void Move()
	{
		if (rand()%100 > 98) Log("Show must go on!");
		else if (rand()%100 > 99) Log("Grrrr... I kill you! >:\\");
		else if (rand()%100 > 95) Log("Hmm...");
		else if (rand()%100 > 95) Log("Aha! He-he-he :-)");
		/**/
		
		Point mn, mx;
		if (HaveCoincidence(mn, mx))
		{
			if (city[me].Dist(mn) <= 4)
				MoveTo(mn.x, mn.y);
		}
		
		while (legionsCount && HaveCoincidence(mn, mx))
		{
			if (HowMuch(mx.x, mx.y) <= legionsCount)
				MoveTo(mx.x, mx.y);
			else
				break;
		}

		/* ,    */		
		if (ourLeg < 10)
		{
			int dist = 0;
			Point find(0, 0);
			while (legionsCount &&  dist < 1000)
			{
				dist = 1000;
			
				for (int i = 0; i < size; i++)
					for (int j = 0; j < size; j++)
						if (map[i][j].owner == -1 && !EnemyConnectedCell(i, j) && OurCell(i, j))
							if (Point(i, j).Dist(city[me]) < dist)
							{
								dist = Point(i, j).Dist(city[me]);
								find = Point(i, j);
							}

				if (dist < 1000)
					MoveTo(find.x, find.y);
				else
				{
					for (int i = 0; i < size; i++)
						for (int j = 0; j < size; j++)
							if (map[i][j].owner == -1 && OurCell(i, j))
								if (Point(i, j).Dist(city[me]) < dist)
								{
									dist = Point(i, j).Dist(city[me]);
									find = Point(i, j);
								}
					if (dist < 1000)
						MoveTo(find.x, find.y);
				}
			}
		}
		else
		{
			//     
			while (legionsCount)
			{
				vector<Point>* p = GetAccessiblePoints();
				if (p->size() > 0)
				{
					int minDist = -1;
					for (size_t i = 0; i < p->size(); i++)
					{
						Point cur(p->operator[](i));
						int newDist = cur.Dist(city[enemy]);
						if ((minDist == -1 || newDist < minDist)
							&& map[cur.x][cur.y].owner == -1 && !EnemyConnectedCell(cur.x, cur.y))
							minDist = newDist;
					}
					vector<Point> closestPoints;
					for (size_t i = 0; i < p->size(); i++)
					{
						Point cur(p->operator[](i));
						if (cur.Dist(city[enemy]) == minDist
							&& map[cur.x][cur.y].owner == -1)
							closestPoints.push_back(cur);
					}
					if (closestPoints.size() == 0) break;
					std::random_shuffle(closestPoints.begin(), closestPoints.end());
					MoveTo(closestPoints.begin()->x, closestPoints.begin()->y);
				}
				else break;
				
				delete p;
			}

			
		}
		/**/
/*			     (   (  - ))
			vector<Point> *ps = GetAccessiblePoints();
			if (ps->size())
			{
				Point p = (*ps)[rand() % ps->size()];
				MoveTo(p.x, p.y);
			}
			delete ps;*/
	}

protected:
	int HowMuch(int x, int y)
	{
		return map[x][y].isVeteran ? 3 : 2;
	}

	bool HaveCoincidence(Point &mn, Point &mx)
	{
		int dx[] = { 0, 1, 0, -1 };
		int dy[] = { 1, 0, -1, 0 };
		
		mn.x = -1;
		mx.x = -1;

		for (int i = 0; i < size; i++)
		{
			for (int j = 0; j < size; j++)
			{
				if (ConnectedWith(me, i, j))
				{
					for (int k = 0; k < 4; k++)
					{
						Point newP(i + dx[k], j + dy[k]);
						if (newP.IsValid(size) && map[newP.x][newP.y].owner == enemy)
						{
							if (mn.x == -1 || city[me].Dist(newP) < city[me].Dist(mn))
								mn = newP;
							if (mx.x == -1)
								mx = newP;
							else
								if (city[me].Dist(newP) > city[me].Dist(mx) || 
									(city[me].Dist(newP) == city[me].Dist(mx) &&
									HowMuch(newP.x, newP.y) < HowMuch(mx.x, mx.y)/* &&
									HowMuch(newP.x, newP.y) <= HowMuch(mx.x, mx.y)*/))
									mx = newP;

						}
					}
				}
			}
		}

		return mn.x != -1;
	}

	vector<Point>* GetAccessiblePoints()
	{
		vector<Point> *ps = new vector<Point>();
		ps->assign(0, Point(0,0));
		int x, y;
		for(y = 0; y < size; ++y)
			for(x = 0; x < size; ++x)
				if (CanMoveTo(x, y))
					ps->push_back(Point(x,y));
		return ps;
	}
	bool CanMoveTo(int x, int y)
	{
		Cell c = map[x][y];
		if (c.owner == me) return false;
		if (c.owner == enemy && legionsCount < 2) return false;
		if (c.owner == enemy && c.isVeteran && legionsCount < 3) return false;
		return ConnectedWith(me, x - 1, y) 
			|| ConnectedWith(me, x + 1, y) 
			|| ConnectedWith(me, x, y - 1) 
			|| ConnectedWith(me, x, y + 1);
	}
	
	bool ConnectedWith(int player, int x, int y)
	{
		if (x < 0 || x >= size || y < 0 || y >= size) 
			return false;
		return map[x][y].owner == player && map[x][y].isConnected;
	}

	static void Log(char* message)
	{
		fprintf(stderr,"%s\n", message);
	}

	void MoveTo(int x, int y)
	{
		int count;
		if (map[x][y].owner != enemy) count = 1;
		else if (map[x][y].isVeteran) count = 3;
		else count = 2;
		if (legionsCount >= count)
		{
			map[x][y].owner = me;
			map[x][y].isVeteran = count > 1;
			map[x][y].isConnected = true;
		}
		int stepD = (count < legionsCount) ? count : legionsCount;
		fprintf(outf, "%d %d %d\n", x, y, stepD);
		legionsCount -= count;
		Reconnect();
	}

	void Reconnect()
	{
		for(int y=0; y<size; y++)
			for(int x=0; x<size; x++)
				map[x][y].isConnected = false;
		DFS(city[0].x, city[0].y, 0);
		DFS(city[1].x, city[1].y, 1);
	}

	void DFS(int x, int y, int me)
	{
		if (x < 0 || x >= size) return;
		if (y < 0 || y >= size) return;
		if (map[x][y].owner != me) return;
		if (map[x][y].isConnected) return;
		map[x][y].isConnected = true;
		DFS(x, y-1, me);
		DFS(x, y+1, me);
		DFS(x-1, y, me);
		DFS(x+1, y, me);
	}
};

char* SampleBot::BOT_NAME = "~Gray Code~";
int SampleBot::maxLegions = 5;

int  main()
{
	SampleBot r(stdin, stdout);
	if (r.InputData()) 
		r.Move();
	else 
		fprintf(stdout, "%s", r.getName());
}
