/*------------------------------------------------------------
TEAM22
A
162
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <iostream>
using namespace std;

const int MAXBUFLEN = 1000;
struct Point
{
	int x, y;
	Point(int x = 0, int y = 0)
	{
		this->x = x;
		this->y = y;
	}
};

struct Cell
{
	int owner;
	bool isVeteran;
	bool isConnected;
	Cell() : owner(-1), isVeteran(false), isConnected(false) {}
};

class SampleBot
{
	static char* BOT_NAME;
	static int maxLegions;
	int legionsCount;
	int me, enemy, size;
	FILE* inf, *outf;

	Point city [2];

	Cell** map;
public:
	SampleBot(FILE* inf = NULL, FILE* outf = NULL) : map(NULL), size(0), legionsCount(maxLegions)
	{
		this->inf = (inf) ? inf : stdin;
		this->outf = (outf) ? outf : stdout;
	}
	~SampleBot()
	{
		if (map)
		{
			int x;
			for(x=0;x<size;++x)
				delete[] map[x];
			delete[] map;
		}
	}
	char* getName()
	{
		return BOT_NAME;
	}
	bool InputData()
	{
		char buffer[MAXBUFLEN];
		int i, x, y;
		if (2 != fscanf(inf, "%d%d", &me, &size))
			return false;
		enemy = 1 - me;
		map = new Cell* [size];
		for(i = 0; i < size; ++i)
			map[i] = new Cell[size];
		for(i = 0; i < 2; i++)
		{
			fscanf(inf,"%d%d",&city[i].x,&city[i].y);
		}
		for (y = 0; y < size; y++)
		{
			for (x = 0; x < size; x++)
			{
				fscanf(inf, "%s", buffer);
				char c1 = buffer[0];
				if (strncmp(buffer,".",1) != 0)
				{
					map[x][y].owner = buffer[1] - '0';
					map[x][y].isVeteran = (c1 == 'v' || c1 == 'V');
					map[x][y].isConnected = (c1 == 'N' || c1 == 'V');
				}
			}
		}
		return true;
	}
	
	void Move()
	{
		if (rand()%100 > 98) Log("Show must go on!");
		else if (rand()%100 > 99) Log("Grrrr... I kill you! >:\\");
		else if (rand()%100 > 95) Log("Hmm...");
		else if (rand()%100 > 95) Log("Aha! He-he-he :-)");

		int pp=0;
		while (legionsCount)
		{
			SetMyBase();
			KillDeadMan();

			for (int x=0; x<size-1; x++)
			{
				for (int l=0; l<3; l++)
				{
					SmartProtect(x+1, x, l);
					SmartProtect(x+1, x+1, l);
					SmartProtect(x, x+1, l);
					SmartProtect(x+1, x, l);
				}
			}
			if (pp>15) break;
			pp++;
		}

		pp=0;
		while (legionsCount)
		{
			vector<Point> *ps = GetAccessiblePoints();
			if (ps->size())
			{
				Point p = (*ps)[rand() % ps->size()];
				MoveTo(p.x, p.y);
			}
			delete ps;
			if (pp>8) break;
			pp++;
		}
	}

	/////////////////////////////////////////////////////////////////////
protected:
	Point GetPoint(int x, int y)
	{
		if (city[0].x==0)
		{
			if (me==0)
			{
				return Point(x, y);
			} else {
				return Point(size-x-1, size-y-1);
			}
		} else {
			if (me!=0)
			{
				return Point(x, y);
			} else {
				return Point(size-x-1, size-y-1);
			}
		}
	}

	void KillDeadMan()
	{
		vector<Point> enm;

		for(int y = 0; y < size; ++y)
			for(int x = 0; x < size; ++x)
				if (map[x][y].owner == enemy) enm.push_back(Point(x, y));

		int mindl=100000;
		int id=-1;
		for (int i=0; i<(int)enm.size(); i++)
		{
			int dl=enm[i].x+enm[i].y;
			if (dl<mindl)
			{
				mindl=dl;
				id=i;
			}
		}

		if (mindl<=4)
		{
			if (!MyConnectedEx(enm[id].x-1, enm[id].y) &&
				!MyConnectedEx(enm[id].x, enm[id].y-1)
				)
			{
				bool bret = MoveToEx(enm[id].x-1, enm[id].y);
				if (!bret) MoveToEx(enm[id].x, enm[id].y-1);
			}
			Protect(enm[id].x, enm[id].y);
		}
	}
	vector<Point>* GetAccessiblePoints()
	{
		vector<Point> *ps = new vector<Point>();
		ps->assign(0, Point(0,0));
		int x, y;
		for(y = 0; y < size; ++y)
			for(x = 0; x < size; ++x)
				if (CanMoveTo(x, y))
					ps->push_back(Point(x,y));
		return ps;
	}
	bool CanMoveTo(int x, int y)
	{
		Cell c = map[x][y];
		if (c.owner == me) return false;
		if (c.owner == enemy && legionsCount < 2) return false;
		if (c.owner == enemy && c.isVeteran && legionsCount < 3) return false;
		return MyConnected(x - 1, y) || MyConnected(x + 1, y) || MyConnected(x, y - 1) || MyConnected(x, y + 1);
	}

	bool MyConnected(int x, int y)
	{
		if (x < 0 || x >= size || y < 0 || y >= size) 
			return false;
		return map[x][y].owner == me && map[x][y].isConnected;
	}

	static void Log(char* message)
	{
		fprintf(stderr,"%s\n", message);
	}

	bool MoveToEx(Point pt) { Point ptn = GetPoint(pt.x, pt.y); return MoveTo(ptn.x, ptn.y); }
	bool MoveToEx(int x, int y)	{ Point ptn = GetPoint(x, y); return MoveTo(ptn.x, ptn.y); }
	bool MyConnectedEx(int x, int y) { Point ptn = GetPoint(x, y); return MyConnected(ptn.x, ptn.y); }

	bool MoveTo(int x, int y)
	{
		//cerr<<x<<" "<<y<<" "<<size<<endl;
		if (x<0 || y<0) return false;
		if (x>=size || y>=size) return false;

		int count;
		if (map[x][y].owner != enemy) count = 1;
		else if (map[x][y].isVeteran) count = 3;
		else count = 2;
		if (legionsCount >= count)
		{
			map[x][y].owner = me;
			map[x][y].isVeteran = count > 1;
			map[x][y].isConnected = true;
			int stepD = (count < legionsCount) ? count : legionsCount;
			fprintf(outf, "%d %d %d\n", x, y, stepD);
			legionsCount -= count;
			Reconnect();
			return true;
		}
		return false;
	}

	void Reconnect()
	{
		for(int y=0; y<size; y++)
			for(int x=0; x<size; x++)
				map[x][y].isConnected = false;
		DFS(city[0].x, city[0].y, 0);
		DFS(city[1].x, city[1].y, 1);
	}

	void Protect(int x, int y)
	{
		if (!MyConnectedEx(x, y)) 
			MoveToEx(x, y);
	}

	void SmartProtect(int x, int y, int level)
	{
		if (!MyConnectedEx(x, y) && (
			(level==0 && map[x][y].owner!=enemy) 
			|| (level==1 && !map[x][y].isVeteran) 
			|| (level==2))
			)
			MoveToEx(x, y);
	}

	void SetMyBase()
	{
		Protect(0, 0);
		Protect(0, 1);

		Protect(1, 0);
		Protect(1, 1);

		Protect(2, 0);
		Protect(0, 2);
	}

	void DFS(int x, int y, int me)
	{
		if (x < 0 || x >= size) return;
		if (y < 0 || y >= size) return;
		if (map[x][y].owner != me) return;
		if (map[x][y].isConnected) return;
		map[x][y].isConnected = true;
		DFS(x, y-1, me);
		DFS(x, y+1, me);
		DFS(x-1, y, me);
		DFS(x+1, y, me);
	}
};

char* SampleBot::BOT_NAME = "Vasia Pupkin";
int SampleBot::maxLegions = 5;

int  main()
{
	SampleBot r(stdin, stdout);
	if (r.InputData()) 
		r.Move();
	else 
		fprintf(stdout, "%s", r.getName());
}
