(*------------------------------------------------------------
TEAM23
A
168
Target: LegionDelphi7; Platform: Win32; Comment: Borland Delphi 7 (Legionaries)
------------------------------------------------------------*)
{$APPTYPE CONSOLE}
program sj_bfs3;
uses SysUtils, Math;
const
	PLAYER_NAME = 'Salavat Julaev';
	MAX_SIZE = 100;
  inf = 1000000;

type
  int = longint;
	TPoint = record
		x: Integer;
		y: Integer;
	end;

	TCell = record
		owner: Integer;
		isVeteran: Boolean;
		isConnected: Boolean;
	end;

	TMap = array[0..MAX_SIZE, 0..MAX_SIZE] of TCell;

var
	me: Integer;
	size: Integer;
	map: TMap;
	legionsCount: Integer;
	city: array[0..1] of TPoint;

procedure InputData();
var
	i: Integer;
	x, y: Integer;
	c1, c2: char;
begin
	legionsCount := 5;
	Readln(me);
	Readln(size);
	for i := 0 to 1 do
	Readln(city[i].x, city[i].y);
	for y := 0 to size-1 do
	begin
		for x := 0 to size - 1 do
		begin
			Read(c1);
			Read(c2);
			if (c1 <> '.') then
			begin
				map[x][y].isVeteran := c1 in ['V', 'v'];
				map[x][y].isConnected := c1 in ['N', 'V'];
				map[x][y].owner := StrToInt(c2);
				Read(c2);
			end
			else
			begin
				map[x][y].isVeteran := false;
				map[x][y].isConnected := false;
				map[x][y].owner := -1;
			end
		end;
		Readln;
	end;
end;

function IsMyConnected(x, y: Integer): Boolean;
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then result := false
	else result := (map[x][y].owner = me) and map[x][y].isConnected;
end;

function CanMoveTo(x, y: Integer): Boolean;
var
	c: TCell;
begin
	c := map[x][y];
	if c.owner = me then result := false
	else if (c.owner >= 0) and (legionsCount < 2) then result := false
	else if (c.owner >= 0) and (c.isVeteran) and (legionsCount < 3) then result := false
	else result := IsMyConnected(x-1, y) or IsMyConnected(x+1, y)
				or IsMyConnected(x, y-1) or IsMyConnected(x, y+1);
end;

procedure DFS(x, y: Integer; owner: Integer);
begin
	if (x < 0) or (x >= size) or (y < 0) or (y >= size) then exit;
	if map[x,y].owner <> owner then exit;
	if map[x,y].isConnected then exit;
	map[x,y].isConnected := true;
	DFS(x, y-1, owner);
	DFS(x, y+1, owner);
	DFS(x-1, y, owner);
	DFS(x+1, y, owner);
end;

//  .       .
procedure Reconnect;
var
	x, y: Integer;
begin
	for y:=0 to size-1 do
		for x:=0 to size-1 do
			map[x,y].isConnected := false;
	DFS(city[0].x, city[0].y, 0);
	DFS(city[1].x, city[1].y, 1);
end;

procedure MoveTo(x, y: Integer);
var
	c: Integer;
begin
	Writeln(ErrOutput, 'go to ', x, ' ', y);
	if (map[x][y].owner = me) or (map[x][y].owner = -1) then c := 1
	else if map[x][y].isVeteran then c := 3
	else c := 2;
	if (legionsCount >= c) then
	begin
		map[x][y].owner := me;
		map[x][y].isVeteran := c > 1;
		map[x][y].isConnected := true;
	end;
	Writeln(x, ' ', y, ' ', Min(legionsCount, c));
	Dec(legionsCount, c);
	Reconnect();
end;

function dist(const a: tpoint): int;
begin
  dist := abs(city[me].x - a.x) + abs(city[me].y - a.y);
end;

procedure Move();
var
	ps: array[0..MAX_SIZE*MAX_SIZE] of TPoint;
	bcount: Integer;

	procedure FindAccessiblePoints;
	var
		x, y: Integer;
	begin
		bcount := 0;
		for y := 0 to size-1 do
			for x := 0 to size-1 do
			begin
				if CanMoveTo(x, y)then
				begin
					ps[bcount].x := x;
					ps[bcount].y := y;
					Inc(bcount);
				end
			end;
	end;

var
	p: TPoint;
	d, i, t: Integer;

procedure swap(var a,b: tpoint);
var t: tpoint;
begin
  t := a; a := b; b := t;
end;

function ishole(p: tpoint): boolean;
var dx, dy: int;
begin
 {
  dx := abs(city[me].x - p.x);
  dy := abs(city[me].y - p.y);
  ishole := (dx mod 2 = 0) and (dx > 1) and (dy mod 2 = 0) and (dy > 1) and (map[p.x, p.y].owner = -1) and (dist(p) >= 5);
  }
  ishole := false;
end;

function enemy(p: tpoint): int;
var r, i, j: int;
begin
  r := 0;
  for i := -2 to 2 do
    for j := -2 to 2 do
      if (abs(i)+abs(j)<=2) and (p.x+i>=0) and (p.y+j>=0) and (p.x+i<size) and (p.y+j<size)  then begin
         with map[p.x+i, p.y+j] do
           if owner = 1-me then begin
             if isveteran then inc(r, 2) else inc(r);
           end;
      end;
  enemy := r;
end;

var
 ds, e, en: int;
 at: boolean;
 
begin
	Writeln(ErrOutput);
	while legionsCount > 0 do
	begin
		FindAccessiblePoints();
		if bcount = 0 then exit;
    d := -inf; en := -inf;

    for i := 0 to bcount-1 do begin
      if not ishole(ps[i]) then begin
        ds := dist(ps[i]);
        e := enemy(ps[i]);
        at := map[ps[i].x, ps[i].y].owner <> -1;
//        if (e > en) or ((e = en) and (ds < d)) or ((e = en) and (ds = d) and at) then begin
        if (ds > d) or ((ds = d) and (e > en)) or ((e = en) and (ds = d) and at) then begin
          p := ps[i];
          d := ds;
          en := e;
        end;
      end;
      {
        if (dist(ps[i]) < d) or ((dist(ps[i]) = d) or (map[ps[i].x, ps[i].y].owner <> -1)) then begin
          d := dist(ps[i]);
          p := ps[i];
        end;
      }
    end;

    if d = inf then begin
      d := -inf;
      for i := 0 to bcount-1 do
        if ishole(ps[i]) then begin
          t := enemy(ps[i]);
          if t > d then begin d := t; p := ps[i]; end;
        end;
    end;
		MoveTo(p.x, p.y);
	end;
end;


begin
	Randomize();
	if SeekEOF then
		Writeln(PLAYER_NAME)
	else
	begin
		InputData();
		Move();
	end;
end.
