/*------------------------------------------------------------
TEAM24
A
170
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
using namespace std;

const int MAXBUFLEN = 1000;
struct Point
{
	int x, y;
	Point(int x = 0, int y = 0)
	{
		this->x = x;
		this->y = y;
	}
};
int dx[]={1,0,-1,0};
int dy[]={0,1,0,-1};

struct Cell
{
	int owner;
	bool isVeteran;
	bool isConnected;
	Cell() : owner(-1), isVeteran(false), isConnected(false) {}
};

class SampleBot
{
	static char* BOT_NAME;
	static int maxLegions;
	int legionsCount;
	int me, enemy, size;
	FILE* inf, *outf;

	Point city [2];

	Cell** map;
public:
	SampleBot(FILE* inf = NULL, FILE* outf = NULL) : map(NULL), size(0), legionsCount(maxLegions)
	{
		this->inf = (inf) ? inf : stdin;
		this->outf = (outf) ? outf : stdout;
	}
	~SampleBot()
	{
		if (map)
		{
			int x;
			for(x=0;x<size;++x)
				delete[] map[x];
			delete[] map;
		}
	}
	char* getName()
	{
		return BOT_NAME;
	}
	bool InputData()
	{
		char buffer[MAXBUFLEN];
		int i, x, y;
		if (2 != fscanf(inf, "%d%d", &me, &size))
			return false;
		enemy = 1 - me;
		map = new Cell* [size];
		for(i = 0; i < size; ++i)
			map[i] = new Cell[size];
		for(i = 0; i < 2; i++)
		{
			fscanf(inf,"%d%d",&city[i].x,&city[i].y);
		}
		for (y = 0; y < size; y++)
		{
			for (x = 0; x < size; x++)
			{
				fscanf(inf, "%s", buffer);
				char c1 = buffer[0];
				if (strncmp(buffer,".",1) != 0)
				{
					map[x][y].owner = buffer[1] - '0';
					map[x][y].isVeteran = (c1 == 'v' || c1 == 'V');
					map[x][y].isConnected = (c1 == 'N' || c1 == 'V');
				}
			}
		}
		return true;
	}
	
	void find_close_enemy(Point& my_enemy){
		my_enemy=city[enemy];
		my_enemy = (my_enemy.x==0)?Point(-1,-1):Point(size,size);
		

		/*int sum1 = city[me].x + city[me].y;
		int sum2 = size*2-1 - sum1;
		int dsum = (city[me].x==0)?1:-1;*/
		for(int i=0;i<size;i++){
			for(int j=0;j<size;j++)/*if(i-j>=0 && i-j<size)*/{
				if(map[i][j].isConnected && map[i][j].owner==enemy && abs(i-city[me].x)+abs(j-city[me].y)<abs(my_enemy.x-city[me].x)+abs(my_enemy.y-city[me].y)){
					my_enemy.x = i;
					my_enemy.y = j;
					//cut_enemies(my_enemy);
				}
			}
		}
		if(my_enemy.x<0 || my_enemy.x>=size)
			for(int i=0;i<size;i++){
				for(int j=0;j<size;j++)/*if(i-j>=0 && i-j<size)*/{
					if(map[i][j].owner==enemy && !map[i][j].isVeteran &&abs(i-city[me].x)+abs(j-city[me].y)<abs(my_enemy.x-city[me].x)+abs(my_enemy.y-city[me].y)){
						my_enemy.x = i;
						my_enemy.y = j;
						//cut_enemies(my_enemy);
					}
				}
			}
		if(my_enemy.x<0 || my_enemy.x>=size)
			for(int i=0;i<size;i++){
				for(int j=0;j<size;j++)/*if(i-j>=0 && i-j<size)*/{
					if(map[i][j].owner==enemy && abs(i-city[me].x)+abs(j-city[me].y)<abs(my_enemy.x-city[me].x)+abs(my_enemy.y-city[me].y)){
						my_enemy.x = i;
						my_enemy.y = j;
						//cut_enemies(my_enemy);
					}
				}
			}
		char mess[80];
		sprintf(mess,"My close enemy is %d %d",my_enemy.x,my_enemy.y);
		Log(mess);
	};
	bool **map2;	
	void cut_enemies(Point my_enemy){
		map2 = new bool*[size];	
		for(int i=0;i<size;++i){
			map2[i] = new bool[size];
			memset(map2[i],0,sizeof(map2[i]));
		}
		cut_enemies_(my_enemy);
		for(int i=0;i<size;++i)
			delete[] map2[i];
		delete[] map2;

	}
	bool cut_enemies_(Point my_enemy){
		char mess[80];
		sprintf(mess,"I am in %d %d",my_enemy.x,my_enemy.y);
		Log(mess);
        if(!CanMoveTo(my_enemy.x,my_enemy.y)){
			return false;
		};
		map2[my_enemy.x][my_enemy.y]=true;
        int ct=0;
		Point Next;
		for(int i=0;i<4;++i)if(my_enemy.x + dx[i]>=0 && my_enemy.x + dx[i]<size && my_enemy.y + dy[i]>=0 && my_enemy.y + dy[i]<size)
			if(!map2[my_enemy.x + dx[i]][my_enemy.y + dy[i]])
				if(map[my_enemy.x + dx[i]][my_enemy.y + dy[i]].owner==enemy)
					ct++, Next.x = my_enemy.x + dx[i], Next.y = my_enemy.y + dy[i];
		 mess[80];
			sprintf(mess,"ct= %d ",ct);
			Log(mess);
		if(ct>1){
			char mess[80];
			sprintf(mess,"Attack enemy is %d %d",my_enemy.x,my_enemy.y);
			Log(mess);
			MoveTo(my_enemy.x, my_enemy.y);
			cut_enemies_(Next);
			return true;
		}
		if(ct==1){
			if(cut_enemies_(Next))return true;
			char mess[80];
			sprintf(mess,"Attack enemy is %d %d",my_enemy.x,my_enemy.y);
			Log(mess);
			MoveTo(my_enemy.x,my_enemy.y);
			cut_enemies_(Next);
		}
		MoveTo(my_enemy.x,my_enemy.y);
		cut_enemies_(Next);
		return true;
	};
	bool built_corner(){
		Point my_pl=city[enemy];
		for(int i=0;i<size;i++){
			for(int j=0;j<size;j++){
				if(CanMoveTo(i,j) && map[i][j].owner==-1 && abs(i-city[me].x)+abs(j-city[me].y) < abs(my_pl.x-city[me].x)+abs(my_pl.y-city[me].y)){
					my_pl.x = i;
					my_pl.y = j;
				}
			}
		}
		if((my_pl.x != city[enemy].x || my_pl.y != city[enemy].y)&&CanMoveTo(my_pl.x,my_pl.y)){
			char mess[80];
			sprintf(mess,"Build village is %d %d",my_pl.x,my_pl.y);
			Log(mess);
			MoveTo(my_pl.x,my_pl.y);
			return true;
		}
		return false;
	}
	void Move()
	{
		/*if (rand()%100 > 98) Log("Show must go on!");
		else if (rand()%100 > 99) Log("Grrrr... I kill you! >:\\");
		else if (rand()%100 > 95) Log("Hmm...");
		else if (rand()%100 > 95) Log("Aha! He-he-he :-)");
		while (legionsCount)
		{
			vector<Point> *ps = GetAccessiblePoints();
			if (ps->size())
			{
				Point p = (*ps)[rand() % ps->size()];
				MoveTo(p.x, p.y);
			}
			delete ps;
		}*/
		Point enemy;
		int tmp=legionsCount;
		do{
			find_close_enemy(enemy);
			cut_enemies(enemy);
			char mess[80];
			sprintf(mess,"Count=%d tmp=%d",legionsCount,tmp);
			Log(mess);
			if(legionsCount == tmp)break;
			tmp = legionsCount;
		}while(1);
		tmp=legionsCount;
		//do{
		while(legionsCount>0){

			fprintf(stderr,"Hi! %d\n", legionsCount);
			if(!built_corner())break;
			if(legionsCount == tmp)break;
			tmp = legionsCount;
		//}while(1);
		}
	}

protected:
	vector<Point>* GetAccessiblePoints()
	{
		vector<Point> *ps = new vector<Point>();
		ps->assign(0, Point(0,0));
		int x, y;
		for(y = 0; y < size; ++y)
			for(x = 0; x < size; ++x)
				if (CanMoveTo(x, y))
					ps->push_back(Point(x,y));
		return ps;
	}
	bool CanMoveTo(int x, int y)
	{
		Cell c = map[x][y];
		if (c.owner == me) return false;
		if (c.owner == enemy && legionsCount < 2) return false;
		if (c.owner == enemy && c.isVeteran && legionsCount < 3) return false;
		return MyConnected(x - 1, y) || MyConnected(x + 1, y) || MyConnected(x, y - 1) || MyConnected(x, y + 1);
	}

	bool MyConnected(int x, int y)
	{
		if (x < 0 || x >= size || y < 0 || y >= size) 
			return false;
		return map[x][y].owner == me && map[x][y].isConnected;
	}

	static void Log(char* message)
	{
		fprintf(stderr,"%s\n", message);
	}

	void MoveTo(int x, int y)
	{
		int count;
		if (map[x][y].owner != enemy) count = 1;
		else if (map[x][y].isVeteran) count = 3;
		else count = 2;
		if (legionsCount >= count)
		{
			map[x][y].owner = me;
			map[x][y].isVeteran = count > 1;
			map[x][y].isConnected = true;
		}
		int stepD = (count < legionsCount) ? count : legionsCount;
		fprintf(outf, "%d %d %d\n", x, y, stepD);
		legionsCount -= count;
		Reconnect();
	}

	void Reconnect()
	{
		for(int y=0; y<size; y++)
			for(int x=0; x<size; x++)
				map[x][y].isConnected = false;
		DFS(city[0].x, city[0].y, 0);
		DFS(city[1].x, city[1].y, 1);
	}

	void DFS(int x, int y, int me)
	{
		if (x < 0 || x >= size) return;
		if (y < 0 || y >= size) return;
		if (map[x][y].owner != me) return;
		if (map[x][y].isConnected) return;
		map[x][y].isConnected = true;
		DFS(x, y-1, me);
		DFS(x, y+1, me);
		DFS(x-1, y, me);
		DFS(x+1, y, me);
	}
};

char* SampleBot::BOT_NAME = "USATU2 c++ Bot";
int SampleBot::maxLegions = 5;

int  main()
{
	SampleBot r(stdin, stdout);
	if (r.InputData()) 
		r.Move();
	else 
		fprintf(stdout, "%s", r.getName());
}
