/*------------------------------------------------------------
TEAM32
A
174
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <queue>
using namespace std;

const int MAXBUFLEN = 1000;
struct Point
{
	int x, y;
	Point(int x = 0, int y = 0)
	{
		this->x = x;
		this->y = y;
	}
};

struct Cell
{
	int owner;
	bool isVeteran;
	bool isConnected;
	Cell() : owner(-1), isVeteran(false), isConnected(false) {}
};

class SampleBot
{
	static char* BOT_NAME;
	static int maxLegions;
	int legionsCount;
	int me, enemy, size;
	FILE* inf, *outf;

	Point city [2];

	Cell** map;
public:
	SampleBot(FILE* inf = NULL, FILE* outf = NULL) : map(NULL), size(0), legionsCount(maxLegions)
	{
		this->inf = (inf) ? inf : stdin;
		this->outf = (outf) ? outf : stdout;
	}
	~SampleBot()
	{
		if (map)
		{
			int x;
			for(x=0;x<size;++x)
				delete[] map[x];
			delete[] map;
		}
	}
	char* getName()
	{
		return BOT_NAME;
	}
	bool InputData()
	{
		char buffer[MAXBUFLEN];
		int i, x, y;
		if (2 != fscanf(inf, "%d%d", &me, &size))
			return false;
		enemy = 1 - me;
		map = new Cell* [size];
		for(i = 0; i < size; ++i)
			map[i] = new Cell[size];
		for(i = 0; i < 2; i++)
		{
			fscanf(inf,"%d%d",&city[i].x,&city[i].y);
		}
		for (y = 0; y < size; y++)
		{
			for (x = 0; x < size; x++)
			{
				fscanf(inf, "%s", buffer);
				char c1 = buffer[0];
				if (strncmp(buffer,".",1) != 0)
				{
					map[x][y].owner = buffer[1] - '0';
					map[x][y].isVeteran = (c1 == 'v' || c1 == 'V');
					map[x][y].isConnected = (c1 == 'N' || c1 == 'V');
				}
			}
		}
		return true;
	}
		
	void Move()
	{
		/*if (rand()%100 > 98) Log("Show must go on!");
		else if (rand()%100 > 99) Log("Grrrr... I kill you! >:\\");
		else if (rand()%100 > 95) Log("Hmm...");
		else if (rand()%100 > 95) Log("Aha! He-he-he :-)");*/
		while (legionsCount)
		{
			vector<Point> *ps = BFS(city[me].x,city[me].y);
			int gp=0,gv=0,gn=0;
			vector<Point> V;
			vector<Point> N;
			vector<Point> P;
			Point pn;
			for (int i=ps->size()-1;i>-1;i--)
			{
				pn = (*ps)[i];
				if (!map[pn.x][pn.y].isVeteran&&map[pn.x][pn.y].owner==(1-me)&&CanMoveTo(pn.x,pn.y))
				{	
					N.push_back(pn);
					gn++;
				}
			}
			Point pp;
			for (int i=0;i<ps->size();i++)
			{
				pp = (*ps)[i];
				if (map[pp.x][pp.y].owner==-1&&CanMoveTo(pp.x,pp.y))
				{				
					P.push_back(pp);
					gp++;
				}
			}
			Point pv;
			for (int i=0;i<ps->size();i++)
			{	
				pv = (*ps)[i];
				if (map[pv.x][pv.y].isVeteran&&map[pv.x][pv.y].owner==(1-me)&&CanMoveTo(pv.x,pv.y))
				{		
					V.push_back(pv);
					gv++;
				}
			}
			if (gv)
			{
				pv=V[(rand()%(V.size())/3)%3];
				MoveTo(pv.x,pv.y);
			}
			else 
				if (gn)
				{
					pn=N[rand()%(N.size())/3];
					MoveTo(pn.x,pn.y);
				}
			else if (gp)
			{
				pp=P[rand()%(P.size())/3];
				MoveTo(pp.x,pp.y);
			}
			else break;
			/*vector<Point> V;
				vector<Point> N;
				vector<Point> P;
				for (int i=ps->size()-1;i>-1;i--)
				{
					p=(*ps)[i];
					if (map[p.x][p.y].owner==-1)
					{
                        P.push_back(p);
					} else
						if (map[p.x][p.y].isVeteran) 
							V.push_back(p); else N.push_back(p);
				}
				if (N.size()>0)
				{
					if (legionsCount>1)
						MoveTo(N[N.size()-1].x,N[N.size()-1].y);
				} else
					if (P.size()>0)
					{
						MoveTo(P[0].x,P[0].y);
					} else
					{
						MoveTo(V[0].x,V[0].y);
					}*/
			delete ps;
		}
	}

protected:
	vector<Point>* GetAccessiblePoints()
	{
		vector<Point> *ps = new vector<Point>();
		ps->assign(0, Point(0,0));
		int x, y;
		for(y = 0; y < size; ++y)
			for(x = 0; x < size; ++x)
				if (CanMoveTo(x, y))
					ps->push_back(Point(x,y));
		return ps;
	}
	bool CanMoveTo(int x, int y)
	{
		Cell c = map[x][y];
		if (c.owner == me) return false;
		if (c.owner == enemy && legionsCount < 2) return false;
		if (c.owner == enemy && c.isVeteran && legionsCount < 3) return false;
		return MyConnected(x - 1, y) || MyConnected(x + 1, y) || MyConnected(x, y - 1) || MyConnected(x, y + 1);
	}

	bool MyConnected(int x, int y)
	{
		if (x < 0 || x >= size || y < 0 || y >= size) 
			return false;
		return map[x][y].owner == me && map[x][y].isConnected;
	}

	static void Log(char* message)
	{
		fprintf(stderr,"%s\n", message);
	}

	void MoveTo(int x, int y)
	{
		int count;
		if (map[x][y].owner != enemy) count = 1;
		else if (map[x][y].isVeteran) count = 3;
		else count = 2;
		if (legionsCount >= count)
		{
			map[x][y].owner = me;
			map[x][y].isVeteran = count > 1;
			map[x][y].isConnected = true;
		}
		int stepD = (count < legionsCount) ? count : legionsCount;
		fprintf(outf, "%d %d %d\n", x, y, stepD);
		legionsCount -= count;
		Reconnect();
	}

	void Reconnect()
	{
		for(int y=0; y<size; y++)
			for(int x=0; x<size; x++)
				map[x][y].isConnected = false;
		DFS(city[0].x, city[0].y, 0);
		DFS(city[1].x, city[1].y, 1);
	}

	void DFS(int x, int y, int me)
	{
		if (x < 0 || x >= size) return;
		if (y < 0 || y >= size) return;
		if (map[x][y].owner != me) return;
		if (map[x][y].isConnected) return;
		map[x][y].isConnected = true;
		DFS(x, y-1, me);
		DFS(x, y+1, me);
		DFS(x-1, y, me);
		DFS(x+1, y, me);
	}
	
	vector<Point>* BFS(int x, int y)
	{
		vector<Point>* result = new vector<Point>();
		queue<Point> s;
		s.push(Point(x,y));
		while (!s.empty())
		{
			Point p=s.front();
			s.pop();
			if (p.x>0)
			{
				if (map[p.x-1][p.y].owner==me)
				{
				map[p.x-1][p.y].owner+=8;
				s.push(Point(p.x-1,p.y));
				}else 
					if(map[p.x-1][p.y].owner<2) 
					{
						map[p.x-1][p.y].owner+=8;
						result->push_back(Point(p.x-1,p.y));
					}
			}
			if (p.x<size-1)
			{
				if (map[p.x+1][p.y].owner==me)
				{
				map[p.x+1][p.y].owner+=8;
				s.push(Point(p.x+1,p.y));
				}else 
					if(map[p.x+1][p.y].owner<2) 
					{
						map[p.x+1][p.y].owner+=8;
						result->push_back(Point(p.x+1,p.y));
					}
			}
			if (p.y>0)
			{
				if (map[p.x][p.y-1].owner==me)
				{
				map[p.x][p.y-1].owner+=8;
				s.push(Point(p.x,p.y-1));
				}else 
					if(map[p.x][p.y-1].owner<2) 
					{
						map[p.x][p.y-1].owner+=8;
						result->push_back(Point(p.x,p.y-1));
					}
			}
			if (p.y<size-1)
			{
				if (map[p.x][p.y+1].owner==me)
				{
				map[p.x][p.y+1].owner+=8;
				s.push(Point(p.x,p.y+1));
				}else 
					if(map[p.x][p.y+1].owner<2) 
					{
						map[p.x][p.y+1].owner+=8;
						result->push_back(Point(p.x,p.y+1));
					}
			}
		}
		for (int x=0;x<size;x++)
			for (int y=0;y<size;y++)
				if (map[x][y].owner>1)
					map[x][y].owner-=8;
		return result;
	}
};

char* SampleBot::BOT_NAME = "0SU 03";
int SampleBot::maxLegions = 5;

int  main()
{
	SampleBot r(stdin, stdout);
	if (r.InputData()) 
		r.Move();
	else 
		fprintf(stdout, "%s", r.getName());
}
