/*------------------------------------------------------------
TEAM34
A
179
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#include <stdio.h>
#include <memory.h>
#include <stdlib.h>
#include <time.h>

#define N 0
#define V 1
#define MAX 40

struct Cell {	
	int play;
	int leg;
	int con;
};

struct Point {
	int x,y;
};

int Abs(int x) {
	return x<0?-x:x;
}

int n;

int X[4]={-1,0,1,0};
int Y[4]={0,-1,0,1};

Cell cell[MAX][MAX];
int player;
Point t1,t2;
int q;

void Read() {
	char str[10];
	int i,j;
	memset(cell,0,sizeof(cell));	
	scanf("%d",&n);
	scanf("%d %d",&t1.x,&t1.y);
	scanf("%d %d",&t2.x,&t2.y);
	for (j=0;j<n;j++) {
		for (i=0;i<n;i++) {
			scanf("%s",str);
			if (str[0] == '.') {
				cell[i][j].play=-1;
			} else if (str[0] == 'N') {
				cell[i][j].play=str[1]-'0';
				cell[i][j].con=1;
				cell[i][j].leg=N;
			} else if (str[0] == 'n') {
				cell[i][j].play=str[1]-'0';
				cell[i][j].con=0;
				cell[i][j].leg=N;
			} else if (str[0] == 'V') {
				cell[i][j].play=str[1]-'0';
				cell[i][j].con=1;
				cell[i][j].leg=V;
			} else if (str[0] == 'v') {
				cell[i][j].play=str[1]-'0';
				cell[i][j].con=0;
				cell[i][j].leg=V;
			}
		}
	}

	if (player==1) {
		Cell t[MAX][MAX];
		for (j=0;j<n;j++) {
			for (i=0;i<n;i++) {
				memcpy(&t[i][j],&cell[n-i-1][n-j-1],sizeof(Cell));
				if (t[i][j].play!=-1) t[i][j].play=!t[i][j].play;
			}
		}
		memcpy(cell,t,sizeof(t));
	}
}

int Count(int a) {
	int i,j;
	int r=0;
	for (j=0;j<n;j++) {
		for (i=0;i<n;i++) {
			if (cell[i][j].play==a) r++;
		}
	}
	return r;
}

int Al(int x, int y) {
	if (cell[x][y].play==0) return 1;
	return 0;
}

int En(int x, int y) {
	if (cell[x][y].play==1) return 1;
	return 0;
}

int Free(int x, int y) {
	if (cell[x][y].play==-1) return 1;
	return 0;
}

int Connect(int x, int y) {
	if (cell[x][y].con==1) return 1;
	return 0;
}

void Print(int x, int y, int c);

void Print(int x, int y) {
	Print(x,y,1);
}

void PrintAttack(int x, int y) {
	if (cell[x][y].leg==N&&q>=2) {
		Print(x,y,2);
	} else
	if (cell[x][y].leg==V&&q>=3) {
		Print(x,y,3);
	}
}

int Dist(int x0, int y0, int x1, int y1) {
	return Abs(x1-x0)+Abs(y1-y0);
}

int In(int x, int y) {
	if (x<0) return 0;
	if (y<0) return 0;
	if (x>n) return 0;
	if (y>n) return 0;
	return 1;
}

int In(int x, int y, int d) {
	if (x+X[d]<0) return 0;
	if (y+Y[d]<0) return 0;
	if (x+X[d]>n) return 0;
	if (y+Y[d]>n) return 0;
	return 1;
}


void DirChange(int x, int y, int d, int &rx, int &ry) {
	rx=x+X[d];
	ry=y+Y[d];
}

int Nov(int x, int y) {
	if (cell[x][y].leg==N) return 1;
	return 0;
}

int Vet(int x, int y) {
	if (cell[x][y].leg==V) return 1;
	return 0;
}

int CanAttack(int x, int y) {
	int x0,y0;
	int d;
	if (q<1) return 0;
	if (Nov(x,y) && q<2) return 0;
	if (Vet(x,y) && q<3) return 0;
	if (!En(x,y)) return 0;	
	if (!In(x,y)) return 0;
	for (d=0;d<4;d++) {
		if (!In(x,y,d)) continue;
		DirChange(x,y,d,x0,y0);
		if (Al(x0,y0) && Connect(x0,y0) ) {
			return 1;
		}
	}
	return 0;
}

int CanMove(int x, int y) {
	int x0,y0;
	int d;
	if (q==0) return 0;
	if (!In(x,y)) return 0;
	if (!Free(x,y)) return 0;
	for (d=0;d<4;d++) {
		if (!In(x,y,d)) continue;
		DirChange(x,y,d,x0,y0);
		if (Al(x0,y0) && Connect(x0,y0) ) {
			return 1;
		}
	}
	return 0;
}

int color[MAX][MAX];

void dfs(int x, int y) {
	if (color[x][y]==1) return;
	if (!Al(x,y)) return;
	if (!In(x,y)) return;
	color[x][y]=1;
	cell[x][y].con=1;
	dfs(x-1,y);
	dfs(x,y-1);
	dfs(x+1,y);
	dfs(x,y+1);
}

void ReConnect() {
	memset(color,0,sizeof(color));
	dfs(0,0);
}

void Print(int x, int y, int c) {
	if (!CanMove(x,y)&&!CanAttack(x,y)) {
		return;
	}
	if (player==0) {
		printf("%d %d %d\n",x,y,c);
	} else {
		printf("%d %d %d\n",n-x-1,n-y-1,c);
	}
	q-=c;
	if (En(x,y)) {
		cell[x][y].play = 0;
		cell[x][y].con = 1;
		cell[x][y].leg = V;
	} else if (Free(x,y)) {
		cell[x][y].play = 0;
		cell[x][y].con = 1;
		cell[x][y].leg = N;
	}
	ReConnect();
}

void Move(int x, int y) {
	if (!In(x,y)) return;
	if (Free(x,y) && q>=1 && CanMove(x,y)) Print(x,y);
}

void MoveAlways(int x, int y) {
	if (CanMove(x,y)) Print(x,y);
	if (!En(x,y)) return;
	if (Nov(x,y) && q>=2) Print(x,y,2);
	if (Vet(x,y) && q>=3) Print(x,y,3);
}

void AttackNovice() {
	int i,j;
	int x,y;
	int d;
	for (j=0;j<n;j++) {
		for (i=0;i<n;i++) {
			if (!Al(i,j)) continue;
			if (!Connect(i,j)) continue;
			for (d=0;d<4;d++) {
				if (!In(i,j,d)) continue;
				DirChange(i,j,d,x,y);
				if (En(x,y) && Nov(x,y) ) {
					if (q>=2) {
						MoveAlways(x,y);
						return;
					}
				}
			}
		}
	}
}

void AttackVeteran() {
	int i,j;
	int x,y;
	int d;
	for (j=0;j<n;j++) {
		for (i=0;i<n;i++) {
			if (!Al(i,j)) continue;
			if (!Connect(i,j)) continue;
			for (d=0;d<4;d++) {
				if (!In(i,j,d)) continue;
				DirChange(i,j,d,x,y);
				if (En(x,y) ) {
					if (q>=2) {
						MoveAlways(x,y);
						return;
					}
				}
			}
		}
	}
}

void Defence() {
	int i,j;
	int min;
	Point minv;
	min=-1;
	int d;
	for (j=0;j<7;j++) {
		for (i=0;i<7;i++) {
			if (!En(i,j)) continue;
			if (!CanAttack(i,j)) continue;
			if (q==2 && Vet(i,j)) continue;
			d=Dist(0,0,i,j);			
			if (d<min||min==-1) {
				min=d;
				minv.x=i;
				minv.y=j;
			}
		}
	}
	if (min!=-1) {
		PrintAttack(minv.x,minv.y);
	}
}

void Center() {
    int i,j;
	int min=-1;
	int max=-1;
	Point v;
	for (j=0;j<n;j++) {
		for (i=0;i<n;i++) {
			if (!Al(i,j)) continue;
			if (!Connect(i,j)) continue;
			if (Abs(i-j)<min||min==-1) {
				min=Abs(i-j);
			}
			if (Abs(i-j)==min && min!=-1) {
				if (i+j>max) {
					max=i+j;
					v.x=i;
					v.y=j;
				}
			}
		}
	}
	//while (!Free(v.x,v.y)) {v.x++;v.y++;}	
	MoveAlways(v.x+1,v.y-1);
	//MoveAlways(v.x+2,v.y-2);
	MoveAlways(v.x-1,v.y+1);
	//MoveAlways(v.x-2,v.y+2);
	MoveAlways(v.x+1,v.y+1);
	MoveAlways(v.x+1,v.y);
	MoveAlways(v.x,v.y+1);
}

void Random() {
	int i,j;
	int pq;
	pq=0;
	Point p[MAX*MAX];
	memset(p,0,sizeof(p));
	for (j=0;j<n;j++) {
		for (i=0;i<n;i++) {
			if ( (CanMove(i,j) && q>1) || (CanAttack(i,j) && q>=2 && Nov(i,j) ) || (CanAttack(i,j) && q>=3 ) ) {
				pq++;
				p[pq].x=i;
				p[pq].y=j;
			}
		}
	}
	if (pq==0) return;
	int a;
	a=rand()%pq+1;
	MoveAlways(p[a].x,p[a].y);
}

int shift=0;

int InCenter() {
	int i,j;
	int xc,yc;
	xc=n/2;
	yc=n/2;
	int c=0;
	for (j=yc-2-shift;j<=yc+2-shift;j++) {
		for (i=xc-2-shift;i<=xc+2-shift;i++) {
			if (!In(i,j)) continue;
			if (Al(i,j)) c++;
		}
	}
	if (c>=5) return 1;
	return 0;
}

int InCorner() {
	int i,j;
	int xc,yc;
	xc=n;
	yc=n;
	int c=0;
	for (j=n-7;j<n;j++) {
		for (i=n-7;i<n;i++) {
			if (!In(i,j)) continue;
			if (Al(i,j)) c++;
		}
	}
	if (c>=2) return 1;
	return 0;
}

void AttackBase() {
	int i,j;
	int min;
	Point minv;
	min=-1;
	int d;
	for (j=n-7;j<n;j++) {
		for (i=n-7;i<n;i++) {
			if (!En(i,j)) continue;
			if (!CanAttack(i,j)) continue;
			if (Vet(i,j)) continue;
			d=Dist(n-1,n-1,i,j);
			if (d<min||min==-1) {
				min=d;
				minv.x=i;
				minv.y=j;
			}
		}
	}
	if (min!=-1) {
		PrintAttack(minv.x,minv.y);
	}
	if (min!=-1) return;
	for (j=n-7;j<n;j++) {
		for (i=n-7;i<n;i++) {
			if (!En(i,j)) continue;
			if (!CanAttack(i,j)) continue;
			if (q==2 && Vet(i,j)) continue;
			d=Dist(n-1,n-1,i,j);
			if (d<min||min==-1) {
				min=d;
				minv.x=i;
				minv.y=j;
			}
		}
	}
	if (min!=-1) {
		PrintAttack(minv.x,minv.y);
	}
}

void Down() {
	int xc,yc,i,j;
	xc=n/2;
	yc=n/2;
	int c;
	for (j=yc-2-shift;j<n;j++) {
		c=0;
		for(i=xc-2-shift;i<xc+shift;i++) {
			if (CanMove(i,j)) {MoveAlways(i,j);c++;}
			if (c>=3) break;
		}
	}
}

void Right() {
	int xc,yc,i,j;
	xc=n/2;
	yc=n/2;
	int c;
	for (i=xc-2-shift;i<n;i++) {
		c=0;
		for(j=yc-2-shift;j<yc+shift;j++) {
			if (CanMove(i,j)) {MoveAlways(i,j);c++;}
			if (c>=3) break;
		}
	}
}

void Step() {
	if (Count(0)==1&&(Count(1)>=1&&Count(1)<=6) && Free(1,0) && Free(0,1) && Free(2,0) && Free(0,2) && Free(1,1) ) {
		Print(1,0);
		Print(0,1);
		Print(1,1);
		Print(2,0);
		Print(0,2);
		return;
	}
	if (Count(0)==6&&(Count(	1)>=1&&Count(1)<=11)&& !Free(1,0) && !Free(0,1) && !Free(2,0) && !Free(0,2) && !Free(1,1) ) {
		/*Print(3,0);
		Print(2,1);
		Print(1,2);
		Print(0,3);
		Print(2,2);*/
		Print(3,0);
		Print(4,0);
		Print(5,0);
		Print(0,3);
		Print(0,4);
		return;
	}
	int i;
	if (InCorner()) {
		AttackBase();
		AttackBase();
	}
	Defence();
	int a;	
	if (InCenter()) {
		a=rand()%2;
		if (a==0) {
			Down();Down();
		} else {
			Right();Right();
		}
		Center();
		Center();
	}
	AttackNovice();
	//AttackNovice();
	AttackVeteran();
	Center();
	Center();
	for (i=1;i<=5;i++) {
		Random();
	}
}

int main() {
	srand(time(0));
	if (scanf("%d",&player)==-1) {
		printf("UdSU1");
		return 0;
	}
	q=5;
	Read();
	Step();
	return 0;
}
