/*------------------------------------------------------------
TEAM36
A
178
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <vector>
using namespace std;

const int MAXBUFLEN = 1000;
struct Point
{
	int x, y;
	Point(int x = 0, int y = 0)
	{
		this->x = x;
		this->y = y;
	}
};

struct Cell
{
	int owner;
	bool isVeteran;
	bool isConnected;
	Cell() : owner(-1), isVeteran(false), isConnected(false) {}
};

class SampleBot
{
	static char* BOT_NAME;
	static int maxLegions;
	int legionsCount;
	int me, enemy, size;
	FILE* inf, *outf;

	Point city [2];

	Cell** map;
public:
	SampleBot(FILE* inf = NULL, FILE* outf = NULL) : map(NULL), size(0), legionsCount(maxLegions)
	{
		this->inf = (inf) ? inf : stdin;
		this->outf = (outf) ? outf : stdout;
	}
	~SampleBot()
	{
		if (map)
		{
			int x;
			for(x=0;x<size;++x)
				delete[] map[x];
			delete[] map;
		}
	}
	char* getName()
	{
		return BOT_NAME;
	}
	bool InputData()
	{
		char buffer[MAXBUFLEN];
		int i, x, y;
		if (2 != fscanf(inf, "%d%d", &me, &size))
			return false;
		enemy = 1 - me;
		map = new Cell* [size];
		for(i = 0; i < size; ++i)
			map[i] = new Cell[size];
		for(i = 0; i < 2; i++)
		{
			fscanf(inf,"%d%d",&city[i].x,&city[i].y);
		}
		for (y = 0; y < size; y++)
		{
			for (x = 0; x < size; x++)
			{
				fscanf(inf, "%s", buffer);
				char c1 = buffer[0];
				if (strncmp(buffer,".",1) != 0)
				{
					map[x][y].owner = buffer[1] - '0';
					map[x][y].isVeteran = (c1 == 'v' || c1 == 'V');
					map[x][y].isConnected = (c1 == 'N' || c1 == 'V');
				}
			}
		}
		return true;
	}
#define pe 1
#define war 2
	Point enemyhome;
	Point myhome;
	bool good(int x, int y){
		return x>=0 && x<size && y>=0 && y<size;
	}
	int getdist(Point p1, Point p2){
		return abs(p1.x-p2.x)+abs(p1.y-p2.y);
	}
	int getdist(int x, int y, int xx, int yy){
		return abs(xx-x)+abs(yy-y);
	}
	bool nearenemy(int x, int y){
		int i,j;
		for(i=x-2;i<=x+2;i++)
			for(j=y-2;j<=y+2;j++)
				if (good(i,j) && map[i][j].owner==enemy && abs(x-i)+abs(y-j)<=2){
					return true;
				}
		return false;
	}
	double getpar(Point p){
		return (double)(p.x+1)/(double)(p.y+1);
	}
	bool CanReachEnemy(int x, int y){
		int i,j;
//		int dist;
        for(i=x-2;i<=x+2;i++)
			for(j=y-2;j<=y+2;j++)
				if (good(i,j) && map[i][j].owner==me && abs(x-i)+abs(y-j)<=2){
					return true;
				}

	}
	bool ex(int x, int y, int dist, Point &res){
		int i,j;
		for(i=x-dist;i<=x+dist;i++)
			for(j=y-dist;j<=y+dist;j++)
				if (good(i,j) && map[i][j].owner==me && CanMoveTo(i,j) && dist==(abs(x-i)+abs(y-j))){
					res=Point(i,j);
					return true;
				}

	}
	int getneib(int x, int y){
		int i, j;
		int res=0;
		for(i=x-2;i<=x+2; i++)
			for(j=y-2;j<=y+2;j++)
				if (good(i,j) && getdist(i,j,x,y)<=2 && map[i][j].owner!=me && map[i][j].owner!=enemy)
					res++;
		return res;

	}
	void greedy(vector<Point> *ps){
		int workx, worky;
		int i;
		int best=-1;
		int bestpar;
		int tmppar;
		for(i=0;i<(*ps).size();i++){
			workx=(*ps)[i].x;
			worky=(*ps)[i].y;
			tmppar=getneib(workx, worky);
			if (best==-1  || bestpar<tmppar){
				best=i;
				bestpar=tmppar;
			}
		}
		if (best==-1)
			best=0;
		MoveTo((*ps)[best].x, (*ps)[best].y);
	}
	void Move()
	{
		int i, j;
		int time;
		if (rand()%100 > 98) Log("Show must go on!");
		else if (rand()%100 > 99) Log("Grrrr... I kill you! >:\\");
		else if (rand()%100 > 95) Log("Hmm...");
		else if (rand()%100 > 95) Log("Aha! He-he-he :-)");
		//bool warstarted=false;
		while (legionsCount)
		{
			if (me==0){
				myhome=Point(0,0);
				enemyhome=Point(size-1, size-1);
			}
			else{
				myhome=Point(size-1,size-1);
				enemyhome=Point(0, 0);
			}
			//swap(city[0], city[1]);
			vector<Point> *ps = GetAccessiblePoints();
			/*if (ps->size())
			{
				Point p = (*ps)[rand() % ps->size()];
				MoveTo(p.x, p.y);
			}*/
			time=pe;
			for(i=0;i<size; i++)
				for(j=0;j<size;j++)
					if (map[i][j].owner==me && nearenemy(i,j)){
						time=war;	
					}
			int mindist=3*size;
			int best=-1;
			double bestpar=20;
			double tmppar;
			int tmpdist;
			int workx, worky;
			if (me==0){
				enemyhome=Point(size-1, size-1);
				if (time==pe){
					for(i=0;i<(*ps).size();i++){
						if (nearenemy((*ps)[i].x, (*ps)[i].y)) 
							continue;
						tmpdist=2*size-(*ps)[i].x-(*ps)[i].y;
						tmppar=getpar((*ps)[i]);
						if (tmpdist<mindist){
							best=i;
							bestpar=getpar((*ps)[i]);
							mindist=tmpdist;
						}
						else if (tmpdist==mindist){
							//tmppar=getpar((*ps)[i]);
							if (abs(tmppar-1)<abs(bestpar-1)){
								best=i;
								bestpar=tmppar;
							}
						}
					}
					if (best==-1){
						bestpar=0;
						best=0;
						for(i=0;i<size;i++){
							workx=(*ps)[i].x;
							worky=(*ps)[i].y;
							tmppar=getdist(workx, worky, myhome.x, myhome.y);
							if (tmppar>bestpar){
								best=0;
								bestpar=tmppar;
							}
						}
					}
					MoveTo((*ps)[best].x, (*ps)[best].y);
				}
				else{
					//warstarted=true;
					Point work;
					Point work1;
					int bestdist=-1;
					Point res;
					
					int mybest=2*size;
					int hisbest=2*size;
					for(i=0;i<size;i++)
						for(j=0;j<size;j++){
							if (map[i][j].owner==me){
								if (mybest>getdist(i,j,enemyhome.x, enemyhome.y))
									mybest=getdist(i,j,enemyhome.x, enemyhome.y);
							}
							else if (map[i][j].owner==enemy){
								if (hisbest>getdist(i,j,myhome.x, myhome.y))
									hisbest=getdist(i,j,myhome.x, myhome.y);
							}
						}
					if (mybest<hisbest){
						bestdist=-1;
						for(i=0;i<size;i++)
							for(j=0;j<size;j++)
								if (map[i][j].owner==enemy && CanMoveTo(i,j)){
									if (bestdist==-1 || getdist(enemyhome,Point(i,j))<bestdist){
										bestdist=getdist(enemyhome, Point(i,j));
										res=Point(i,j);
									}
								}
						if (bestdist!=-1){
							MoveTo(res.x,res.y);
							continue;
						}
					}
					else{
						bestdist=-1;
						for(i=0;i<size;i++)
							for(j=0;j<size;j++)
								if (map[i][j].owner==enemy && CanMoveTo(i,j)){
									if (bestdist==-1 || getdist(myhome, Point(i,j))<bestdist){
										bestdist=getdist(myhome, Point(i,j));
										res=Point(i,j);
									}
								}
						if (bestdist!=-1){
							MoveTo(res.x,res.y);
							continue;
						}
					}
						/*for(i=0;i<size;i++)
							for(j=0;j<size;j++){
								workx=i;
								worky=j;
								if (map[i][j].owner==enemy && ex(i,j,2,work) && legionsCount>=1+3*map[i][j].isVeteran+2*!map[i][j].isVeteran){
									work1=Point((work.x+workx+1)/2,(work.y+worky+1)/2);
									if (CanMoveTo(work1.x, work1.y)){
										killed=true;
										MoveTo(work1.x, work1.y);
										if (CanMoveTo(workx, worky)){
											MoveTo(workx, worky);
										}
										break;
									}
									
								}
						}
						if (killed) continue;
						for(i=0;i<(*ps).size();i++){
							workx=(*ps)[i].x;
							worky=(*ps)[i].y;
							MoveTo(workx, worky);
						}*/
					greedy(ps);
				}	
				
			}
				
			else{
				//MoveTo((*ps)[0].x, (*ps)[0].y);
				enemyhome=Point(0, 0);
				if (time==pe){
					for(i=0;i<(*ps).size();i++){
						if (nearenemy((*ps)[i].x, (*ps)[i].y)) 
							continue;
						tmpdist=(*ps)[i].x+(*ps)[i].y;
						tmppar=getpar((*ps)[i]);
						if (tmpdist<mindist){
							best=i;
							bestpar=getpar((*ps)[i]);
							mindist=tmpdist;
						}
						else if (tmpdist==mindist){
							//tmppar=getpar((*ps)[i]);
							if (abs(tmppar-1)<abs(bestpar-1)){
								best=i;
								bestpar=tmppar;
							}
						}
					}
					if (best==-1){
						bestpar=0;
						best=0;
						for(i=0;i<size;i++){
							workx=(*ps)[i].x;
							worky=(*ps)[i].y;
							tmppar=getdist(workx, worky, myhome.x, myhome.y);
							if (tmppar>bestpar){
								best=0;
								bestpar=tmppar;
							}
						}
					}
					MoveTo((*ps)[best].x, (*ps)[best].y);
				}
				else{
					//warstarted=true;
					Point work;
					Point work1;
					int bestdist=-1;
					Point res;
					int mybest=2*size;
					int hisbest=2*size;
					for(i=0;i<size;i++)
						for(j=0;j<size;j++){
							if (map[i][j].owner==me){
								if (mybest>getdist(i,j,enemyhome.x, enemyhome.y))
									mybest=getdist(i,j,enemyhome.x, enemyhome.y);
							}
							else if (map[i][j].owner==enemy){
								if (hisbest>getdist(i,j,myhome.x, myhome.y))
									hisbest=getdist(i,j,myhome.x, myhome.y);
							}
						}
						if (mybest<hisbest){
							bestdist=-1;
							for(i=0;i<size;i++)
								for(j=0;j<size;j++)
									if (map[i][j].owner==enemy && CanMoveTo(i,j)){
										if (bestdist==-1 || getdist(enemyhome, Point(i,j))<bestdist){
											bestdist=getdist(enemyhome, Point(i,j));
											res=Point(i,j);
										}
									}
						}
						else{
							bestdist=-1;
							for(i=0;i<size;i++)
								for(j=0;j<size;j++)
									if (map[i][j].owner==enemy && CanMoveTo(i,j)){
										if (bestdist==-1 || getdist(myhome, Point(i,j))<bestdist){
											bestdist=getdist(myhome, Point(i,j));
											res=Point(i,j);
										}
									}
							if (bestdist!=-1){
								MoveTo(res.x,res.y);
								continue;
							}
						}
					if (bestdist!=-1){
						MoveTo(res.x,res.y);
						continue;
					}
					greedy(ps);
					
				}
			}
				
					 
			
			
			delete ps;
		}
	}

protected:
	vector<Point>* GetAccessiblePoints()
	{
		vector<Point> *ps = new vector<Point>();
		ps->assign(0, Point(0,0));
		int x, y;
		for(y = 0; y < size; ++y)
			for(x = 0; x < size; ++x)
				if (CanMoveTo(x, y))
					ps->push_back(Point(x,y));
		return ps;
	}
	bool CanMoveTo(int x, int y)
	{
		Cell c = map[x][y];
		if (c.owner == me) return false;
		if (c.owner == enemy && legionsCount < 2) return false;
		if (c.owner == enemy && c.isVeteran && legionsCount < 3) return false;
		return MyConnected(x - 1, y) || MyConnected(x + 1, y) || MyConnected(x, y - 1) || MyConnected(x, y + 1);
	}

	bool MyConnected(int x, int y)
	{
		if (x < 0 || x >= size || y < 0 || y >= size) 
			return false;
		return map[x][y].owner == me && map[x][y].isConnected;
	}

	static void Log(char* message)
	{
		fprintf(stderr,"%s\n", message);
	}

	void MoveTo(int x, int y)
	{
		int count;
		if (map[x][y].owner != enemy) count = 1;
		else if (map[x][y].isVeteran) count = 3;
		else count = 2;
		if (legionsCount >= count)
		{
			map[x][y].owner = me;
			map[x][y].isVeteran = count > 1;
			map[x][y].isConnected = true;
		}
		int stepD = (count < legionsCount) ? count : legionsCount;
		//if (me==0)
			fprintf(outf, "%d %d %d\n", x, y, stepD);
		//else
		//	fprintf(outf, "%d %d %d\n", size-x-1, size-y-1, stepD);

		legionsCount -= count;
		Reconnect();
	}

	void Reconnect()
	{
		for(int y=0; y<size; y++)
			for(int x=0; x<size; x++)
				map[x][y].isConnected = false;
		DFS(city[0].x, city[0].y, 0);
		DFS(city[1].x, city[1].y, 1);
	}

	void DFS(int x, int y, int me)
	{
		if (x < 0 || x >= size) return;
		if (y < 0 || y >= size) return;
		if (map[x][y].owner != me) return;
		if (map[x][y].isConnected) return;
		map[x][y].isConnected = true;
		DFS(x, y-1, me);
		DFS(x, y+1, me);
		DFS(x-1, y, me);
		DFS(x+1, y, me);
	}
};

char* SampleBot::BOT_NAME = "PSU 1 Bot";
int SampleBot::maxLegions = 5;

int  main()
{
	SampleBot r(stdin, stdout);
	if (r.InputData()) 
		r.Move();
	else 
		fprintf(stdout, "%s", r.getName());
}
