/*------------------------------------------------------------
TEAM47
A
178
Target: LegionMSVC7; Platform: Win32; Comment: MS Visual C++ 7 (Legionaries)
------------------------------------------------------------*/
#include <cstdio>
#include <queue>
#define MAX 128
#define INF 1000000000

#define Abs(a) ((a)>0?(a):-(a))
#define Max(a,b) ((a)>(b)?(a):(b))
using namespace std;

int n;

struct st
{
	int x, y;
	st() {}
	st(int _x, int _y): x(_x), y(_y) {}

	void Read()
	{
		scanf("%d %d", &x, &y);
	}

	bool fit()
	{
		return (x>=0 && x<n && y>=0 && y<n);
	}

	int Dist(const st&A)
	{
		return (Abs(x-A.x) + Abs(y-A.y));
	}
};

int turn;
bool isVeteran[MAX][MAX];
int a[MAX][MAX];
int turnsLeft = 5;
st start[2];

void Read()
{
	if ( scanf("%d %d", &turn, &n)!=2 )
	{
		printf("Krivetko program\n");
		return;
	}

	start[turn].Read();
	start[1-turn].Read();

	int i, j;
	char tmp[MAX][MAX][10];
	for (i=0;i<n;i++)
		for (j=0;j<n;j++)
		{
			scanf("%s", tmp[i][j]);
			if ( tmp[i][j][0]=='.' ) a[i][j] = -1;
			else
			{
				if ( tmp[i][j][0]=='V' || tmp[i][j][0]=='v' ) isVeteran[i][j] = true;
				if ( tmp[i][j][1]=='0' ) a[i][j] = turn;
				else a[i][j] = 1-turn;
			}
		}
}

void DoTurn(int x, int y, int kol)
{
	printf("%d %d %d\n", y, x, kol);
	a[x][y] = 0;
	if ( kol>1 ) isVeteran[x][y] = true;
	turnsLeft -= kol;
}

int dx[4]={1, 0, -1, 0};
int dy[4]={0, 1, 0, -1};

int par[MAX][MAX], dist[MAX][MAX], bestpar[MAX][MAX];

int Limit(int x, int y)
{
	if ( a[x][y]!=1 ) return 0;
	if ( isVeteran[x][y] ) return 3;
	return 2;
}

int getNearest(st now, st &target)
{
	queue<st> q;
	q.push(now);
	int i, j, k;
	for (i=0;i<n;i++)
		for (j=0;j<n;j++)
			dist[i][j] = INF;

	dist[now.x][now.y] = 0;

	while ( !q.empty() )
	{
		now = q.front(); q.pop();
		for (k=0;k<4;k++)
		{
			st next = st(now.x+dx[k], now.y+dy[k]);
			if ( !next.fit() ) continue;
			if ( Limit(next.x, next.y)>turnsLeft )  continue;

			if ( dist[next.x][next.y]>dist[now.x][now.y]+1 )
			{
				dist[next.x][next.y] = dist[now.x][now.y]+1;
				par[next.x][next.y] = n*now.x+now.y;
				q.push(next);
			}
		}
	}

	int ret = INF;	
	for (i=0;i<n;i++)
		for (j=0;j<n;j++)
			if ( ret>dist[i][j] && a[i][j]==1 ) 
			{
				if ( isVeteran[i][j] && turnsLeft<3 ) continue;
				if ( turnsLeft<2 ) continue;

				ret = dist[i][j];
				target = st(i, j);
			}

	return ret;
}
	
bool isConnected[MAX][MAX];

void bfs(st now)
{
	queue<st> q;
	int i, j;
	for (i=0;i<n;i++)
		for (j=0;j<n;j++)
			isConnected[i][j] = false;
	isConnected[now.x][now.y] = true;
	q.push(now);
		
	while ( !q.empty() )
	{
		now = q.front(); q.pop();
		for (i=0;i<4;i++)
		{
			st next = st(now.x+dx[i], now.y+dy[i]);
			if ( !next.fit() ) continue;
			if ( isConnected[next.x][next.y] ) continue;
			if ( a[next.x][next.y]!=0 ) continue;
			q.push(next);
			isConnected[next.x][next.y] = true;
		}
	}
}

void Solve()
{
	if ( turnsLeft==0 ) return;

	int i, j, t, k;

	bfs( st(start[0].x, start[0].y) );

	st target;
	int deffence = getNearest(start[0], target);
	bool wasAttacks = false;
	for (i=0;i<n;i++)
		for (j=0;j<n;j++)
			if ( isVeteran[i][j] ) wasAttacks = true;

	int mn = -1, mi, mj;
	for (i=0;i<n;i++)
		for (j=0;j<n;j++)
			if ( isConnected[i][j] && a[i][j]==0 )
			{
				st target;
				int tec = getNearest(st(i, j), target);

				if ( tec!=INF )
					if ( mn==-1 || tec<mn || (deffence>5 && tec==mn && start[0].Dist(st(i, j))>start[0].Dist(st(mi, mj)) ) || 
						(deffence<=5 && tec==mn && start[0].Dist(st(i, j))<start[0].Dist(st(mi, mj)) ) )
					{  
						mn = tec;
						mi = target.x;
						mj = target.y;
						memcpy(bestpar, par, MAX*sizeof(par[0]));
					}
			}

	if ( deffence<=5 )
	{
		for (i=0;i<n;i++)
			for (j=0;j<n;j++)
				if ( Max(Abs(i-start[0].x), Abs(j-start[0].y))==14 )
					if ( a[i][j]==1 && Limit(i, j)<=turnsLeft )
					{
						for (k=0;k<4;k++)
						{
							st next = st(i+dx[k], j+dy[k]);
							if ( !next.fit() ) continue;
							if ( a[next.x][next.y]==0 && isConnected[next.x][next.y] )
							{
      						DoTurn(i, j, Limit(i, j));
      						Solve();
      						return;
							}
						}
			
					}

		for (i=0;i<n;i++)
			for (j=0;j<n;j++)
				if ( Max(Abs(i-start[0].x), Abs(j-start[0].y))==7 )
					if ( a[i][j]==1 && Limit(i, j)<=turnsLeft )
					{
						for (k=0;k<4;k++)
						{
							st next = st(i+dx[k], j+dy[k]);
							if ( !next.fit() ) continue;
							if ( a[next.x][next.y]==0 && isConnected[next.x][next.y] )
							{
      						DoTurn(i, j, Limit(i, j));
      						Solve();
      						return;
							}
						}
			
					}

		for (i=0;i<n;i++)
			for (j=0;j<n;j++)
				if ( Max(Abs(i-start[0].x), Abs(j-start[0].y))==5 )
					if ( a[i][j]==1 && Limit(i, j)<=turnsLeft )
					{
						for (k=0;k<4;k++)
						{
							st next = st(i+dx[k], j+dy[k]);
							if ( !next.fit() ) continue;
							if ( a[next.x][next.y]==0 && isConnected[next.x][next.y] )
							{
      						DoTurn(i, j, Limit(i, j));
      						Solve();
      						return;
							}
						}
			
					}

		for (i=0;i<n;i++)
			for (j=0;j<n;j++)
				if ( Max(Abs(i-start[0].x), Abs(j-start[0].y))==3 )
					if ( a[i][j]==1 && Limit(i, j)<=turnsLeft )
					{
						for (k=0;k<4;k++)
						{
							st next = st(i+dx[k], j+dy[k]);
							if ( !next.fit() ) continue;
							if ( a[next.x][next.y]==0 && isConnected[next.x][next.y] )
							{
      						DoTurn(i, j, Limit(i, j));
      						Solve();
      						return;
							}
						}
			
					}
	}

	if ( mn!=-1 )	
	{
		if ( mn==1 )
		{
			if ( Limit(mi, mj)<=turnsLeft )
			{
				DoTurn(mi, mj, Limit(mi, mj));
				Solve();
				return;
			}
		}
		else
		{
			if ( wasAttacks || turnsLeft-mn>=3 || mn>=4 )
			{
				int x = bestpar[mi][mj]/n;
				int y = bestpar[mi][mj]%n;
				while ( a[x][y]!=0 )
				{  
					mi = x; mj = y;
					x = bestpar[mi][mj]/n;
					y = bestpar[mi][mj]%n;
				}

				DoTurn(mi, mj, 1);
				Solve();
				return;
			}
		}
	}

	st nr = st(-1, -1);
	for (i=0;i<n;i++)
		for (j=0;j<n;j++)
			if ( isConnected[i][j] && a[i][j]==0 )
				for (t=0;t<4;t++)
				{
					st next = st(i+dx[t], j+dy[t]);
					if ( !next.fit() ) continue;
					if ( a[next.x][next.y]==-1 )
						if ( nr.x==-1 || start[0].Dist(nr)>start[0].Dist(next) )
						{
							nr = next;
						}
				}
	
	if ( nr.x!=-1 )
	{
		DoTurn(nr.x, nr.y, 1);
		Solve();
		return;
	}
}

int main()
{
//	freopen("input.txt", "rt", stdin);

   Read();
   Solve();

	return 0;
}
